﻿// Author: Orlys
// Github: https://github.com/Orlys

namespace Yuuna
{
    using System;
    using System.Text;


    using Yuuna.Contracts.Optimization;
    using Yuuna.Contracts.Modules;
    using Yuuna.Contracts.TextSegmention;
    using Yuuna.Recognition.Speech;
    using Yuuna.Semantics;
    using Yuuna.TextSegmention;
    using Yuuna.Common.Utilities;
    using System.Threading.Tasks;
    using System.Reflection;
    using System.Linq;

    internal class EntryPoint
    {
        public static void Main(string[] args)
        {
            //var mc = ModuleManager.Instance;
            //foreach (var m in mc.Modules)
            //{
            //    Console.WriteLine(m.Name);
            //}
            //Console.WriteLine("----");
            //Console.ReadKey();
            //mc.UnloadAll();
            //foreach (var m in mc.Modules)
            //{
            //    Console.WriteLine(m.Name);
            //} 
            //Console.WriteLine("----");
            //Console.ReadKey();
            //mc.ReloadAll();  
            //foreach (var m in mc.Modules)
            //{
            //    Console.WriteLine(m.Name);
            //}

            Send("打開門");
            return;

            Send("開燈");
            try
            {
                var stt = SpeechRecognizer.Create("secret.json");
                stt.RecognizeCompleted += a =>
                {
                    if (a.Count > 0)
                    {
                        Console.WriteLine("## Google 語音: " + a[0].Transcript);
                        Send(a[0].Transcript);
                    }
                };

                Console.WriteLine("## Proof of Concept Ver.");
                Console.WriteLine("可以叫我開關燈或者開關門，其他的我還不會");

                Console.WriteLine("按下 Enter 鍵開始錄音，任意鍵離開");
                Loop:
                if(Console.ReadKey().Key == ConsoleKey.Enter)
                { 
                    using (stt.Recognize())
                    {
                        Console.WriteLine("按下 Enter 停止錄音，任意鍵離開"); 
                        if(Console.ReadKey().Key == ConsoleKey.Enter)
                            goto Loop;
                    }
                } 
            }
            catch (Exception e)
            {
                Console.WriteLine(e.Message);
                Console.ReadKey();
            } 
        }

        public static void Send(string text)
        {
            var segmenter = new JiebaTextSegmenter() as ITextSegmenter;
            var allPlugins = ModuleManager.Instance.Modules;
            foreach (var item in allPlugins)
            {
                item.Initialize(segmenter, new GroupManager());
                Console.WriteLine("已載入模組: " + item.GetType().AssemblyQualifiedName);
            }

            Console.WriteLine("我: " + text);
            var cutted = segmenter.Cut(text);
            Console.WriteLine($"來自分詞器 {segmenter.Name} 的分詞結果: [ {string.Join(", ", cutted)} ]");

            IStrategy plan = new DefaultStrategy();
            var alternative = plan.FindBest(allPlugins.Select(x=>x.PatternSet).ToArray(), cutted);
            switch (alternative.Status)
            {
                case Status.Invalid:
                    Console.WriteLine("無效的模組");
                    break;
                case Status.Optimal:
                    alternative.Matches[0].Pattern.Owner.Patterns.TryGet(alternative.Matches[0].Pattern, out var bag);
                    var r = bag.Invoke(alternative.Matches[0]);
                    Console.WriteLine(r.Mood + " | " + r.Message);
                    break;
                case Status.Closest:
                    Console.WriteLine("closest");
                    break;
                case Status.Proposition:
                    Console.WriteLine("proposition");
                    break;
                case Status.Paradox:
                    Console.WriteLine("paradox");
                    break;
                case Status.NoModuleInstalled:
                    Console.WriteLine("noModuleInstalled");
                    break;
                default:
                    break;
            }



            //var list = new List<IScore>();
            //foreach (var p in allPlugins)
            //    list.AddRange(p.Evaluate(cutted));
            //list.Sort(ScoreComparer.Default);

            //var sb = new StringBuilder("Bot: ");
            //var best = list.LastOrDefault();
            //if (best is null)
            //    sb.Append("我不懂你的意思");
            //else if (best.IsCompacted)
            //{
            //    var resp = best.Owner.SelectBest(best).Invoke(best);
            //    Console.WriteLine(resp.Mood.ToString());
            //    sb.Append(resp.Message);
            //}
            //else
            //{
            //    var choices = list.Where(s => s.Missing.Count <= 1).ToImmutableArray();
            //    switch (choices.Length)
            //    {
            //        case 1:
            //            {
            //                Console.WriteLine("#1");
            //                sb.Append("你" + new[] { "是想", "想要" }.RandomTakeOne() + " ");
            //                sb.Append(choices.Select(x => x.Pattern.ToImmutable().Aggregate(string.Empty, (s, g) => s += g.ToImmutable().RandomTakeOne().ToImmutable().RandomTakeOne())));
            //                sb.Append(" 嗎?");
            //            }
            //            break;

            //        case 2:
            //            {
            //                Console.WriteLine("#2");
            //                sb.Append("你" + new[] { "是想", "想要" }.RandomTakeOne() + " ");
            //                sb.AppendJoin(" 還是 ", choices.Select(x => x.Pattern.ToImmutable().Aggregate(string.Empty, (s, g) => s += g.ToImmutable().RandomTakeOne().ToImmutable().RandomTakeOne())));
            //                sb.Append(" ?");
            //            }
            //            break;

            //        default:
            //            Console.WriteLine("#n");
            //            sb.Append("我不太清楚你想做什麼");
            //            break;
            //    }
            //}

            //Console.WriteLine(sb);
        }
    }
}